jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 48 | export USE_JACK="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 49 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 50 | # If dx was not set by the environment variable, assume it is in the path. |
| 51 | if [ -z "$DX" ]; then |
| 52 | export DX="dx" |
| 53 | fi |
| 54 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 55 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 56 | if [ -z "$JASMIN" ]; then |
| 57 | export JASMIN="jasmin" |
| 58 | fi |
| 59 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 60 | # If smali was not set by the environment variable, assume it is in the path. |
| 61 | if [ -z "$SMALI" ]; then |
| 62 | export SMALI="smali" |
| 63 | fi |
| 64 | |
| 65 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 66 | if [ -z "$DXMERGER" ]; then |
| 67 | export DXMERGER="dexmerger" |
| 68 | fi |
| 69 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 70 | # If jack was not set by the environment variable, assume it is in the path. |
| 71 | if [ -z "$JACK" ]; then |
| 72 | export JACK="jack" |
| 73 | fi |
| 74 | |
| 75 | # If the tree is compiled with Jack, build test with Jack by default. |
| 76 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 77 | USE_JACK="true" |
| 78 | fi |
| 79 | |
| 80 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 81 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 82 | export ANDROID_BUILD_TOP=$oldwd |
| 83 | fi |
| 84 | |
| 85 | # If JACK_VM_COMMAND is not set, assume it launches the prebuilt jack-launcher. |
| 86 | if [ -z "$JACK_VM_COMMAND" ]; then |
| 87 | if [ ! -z "$TMPDIR" ]; then |
| 88 | jack_temp_dir="-Djava.io.tmpdir=$TMPDIR" |
| 89 | fi |
| 90 | export JACK_VM_COMMAND="java -Dfile.encoding=UTF-8 -Xms2560m -XX:+TieredCompilation $jack_temp_dir -jar $ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack-launcher.jar" |
| 91 | fi |
| 92 | |
| 93 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 94 | if [ -z "$JACK_CLASSPATH" ]; then |
| 95 | export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
| 96 | fi |
| 97 | |
| 98 | # If JACK_JAR is not set, assume it is located in the prebuilts directory. |
| 99 | if [ -z "$JACK_JAR" ]; then |
| 100 | export JACK_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack.jar" |
| 101 | fi |
| 102 | |
| 103 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 104 | if [ -z "$JILL_JAR" ]; then |
| 105 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 106 | fi |
| 107 | |
| 108 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 109 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 110 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 111 | info="info.txt" |
| 112 | build="build" |
| 113 | run="run" |
| 114 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 115 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 116 | output="output.txt" |
| 117 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 118 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 119 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 120 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 121 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 123 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 124 | |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 125 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 126 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 127 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 128 | dev_mode="no" |
| 129 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 130 | debug_mode="no" |
| 131 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 132 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 133 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 134 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 135 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 136 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 137 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 138 | basic_verify="false" |
| 139 | gc_verify="false" |
| 140 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 141 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 142 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 143 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 144 | have_dex2oat="yes" |
| 145 | have_patchoat="yes" |
| 146 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 147 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 148 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 149 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 150 | |
| 151 | while true; do |
| 152 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 153 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 154 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 155 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 156 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame^] | 157 | elif [ "x$1" = "x--use-java-home" ]; then |
| 158 | if [ -n "${JAVA_HOME}" ]; then |
| 159 | export JAVA="${JAVA_HOME}/bin/java" |
| 160 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 161 | else |
| 162 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 163 | usage="yes" |
| 164 | fi |
| 165 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 166 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 167 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 168 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 169 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 170 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 171 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 172 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame^] | 173 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 174 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 175 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 176 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 177 | testlib="arttest" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 178 | shift |
| 179 | elif [ "x$1" = "x--dalvik" ]; then |
| 180 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 181 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 182 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 183 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 184 | have_dex2oat="no" |
| 185 | shift |
| 186 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 187 | have_patchoat="no" |
| 188 | shift |
| 189 | elif [ "x$1" = "x--no-image" ]; then |
| 190 | have_image="no" |
| 191 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 192 | elif [ "x$1" = "x--pic-image" ]; then |
| 193 | pic_image_suffix="-pic" |
| 194 | shift |
| 195 | elif [ "x$1" = "x--pic-test" ]; then |
| 196 | run_args="${run_args} --pic-test" |
| 197 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 198 | elif [ "x$1" = "x--relocate" ]; then |
| 199 | relocate="yes" |
| 200 | shift |
| 201 | elif [ "x$1" = "x--no-relocate" ]; then |
| 202 | relocate="no" |
| 203 | shift |
| 204 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 205 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 206 | prebuild_mode="yes" |
| 207 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 208 | elif [ "x$1" = "x--debuggable" ]; then |
| 209 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 210 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 211 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 212 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 213 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 214 | prebuild_mode="no" |
| 215 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 216 | elif [ "x$1" = "x--gcverify" ]; then |
| 217 | basic_verify="true" |
| 218 | gc_verify="true" |
| 219 | shift |
| 220 | elif [ "x$1" = "x--gcstress" ]; then |
| 221 | basic_verify="true" |
| 222 | gc_stress="true" |
| 223 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 224 | elif [ "x$1" = "x--image" ]; then |
| 225 | shift |
| 226 | image="$1" |
| 227 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 228 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 229 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 230 | shift |
| 231 | option="$1" |
| 232 | run_args="${run_args} -Xcompiler-option $option" |
| 233 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 234 | elif [ "x$1" = "x--runtime-option" ]; then |
| 235 | shift |
| 236 | option="$1" |
| 237 | run_args="${run_args} --runtime-option $option" |
| 238 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 239 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 240 | shift |
| 241 | gdb_arg="$1" |
| 242 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 243 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 244 | elif [ "x$1" = "x--debug" ]; then |
| 245 | run_args="${run_args} --debug" |
| 246 | shift |
| 247 | elif [ "x$1" = "x--gdb" ]; then |
| 248 | run_args="${run_args} --gdb" |
| 249 | dev_mode="yes" |
| 250 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 251 | elif [ "x$1" = "x--strace" ]; then |
| 252 | strace="yes" |
| 253 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 254 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 255 | elif [ "x$1" = "x--zygote" ]; then |
| 256 | run_args="${run_args} --zygote" |
| 257 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 258 | elif [ "x$1" = "x--interpreter" ]; then |
| 259 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 260 | image_suffix="-interpreter" |
| 261 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 262 | elif [ "x$1" = "x--jit" ]; then |
| 263 | run_args="${run_args} --jit" |
Andreas Gampe | 8a159fd | 2015-09-21 15:14:38 -0700 | [diff] [blame] | 264 | image_suffix="-jit" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 265 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 266 | elif [ "x$1" = "x--optimizing" ]; then |
| 267 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 268 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 269 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 270 | elif [ "x$1" = "x--quick" ]; then |
| 271 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 272 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 273 | elif [ "x$1" = "x--no-verify" ]; then |
| 274 | run_args="${run_args} --no-verify" |
| 275 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 276 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
| 277 | run_args="${run_args} --verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 278 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 279 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 280 | elif [ "x$1" = "x--no-optimize" ]; then |
| 281 | run_args="${run_args} --no-optimize" |
| 282 | shift |
| 283 | elif [ "x$1" = "x--no-precise" ]; then |
| 284 | run_args="${run_args} --no-precise" |
| 285 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 286 | elif [ "x$1" = "x--invoke-with" ]; then |
| 287 | shift |
| 288 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 289 | if [ "x$what" = "x" ]; then |
| 290 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 291 | usage="yes" |
| 292 | break |
| 293 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 294 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 295 | shift |
| 296 | elif [ "x$1" = "x--dev" ]; then |
| 297 | run_args="${run_args} --dev" |
| 298 | dev_mode="yes" |
| 299 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 300 | elif [ "x$1" = "x--build-only" ]; then |
| 301 | build_only="yes" |
| 302 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 303 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 304 | USE_JACK="false" |
| 305 | shift |
| 306 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 307 | USE_JACK="true" |
| 308 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 309 | elif [ "x$1" = "x--output-path" ]; then |
| 310 | shift |
| 311 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 312 | if [ "x$tmp_dir" = "x" ]; then |
| 313 | echo "$0 missing argument to --output-path" 1>&2 |
| 314 | usage="yes" |
| 315 | break |
| 316 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 317 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 318 | elif [ "x$1" = "x--android-root" ]; then |
| 319 | shift |
| 320 | if [ "x$1" = "x" ]; then |
| 321 | echo "$0 missing argument to --android-root" 1>&2 |
| 322 | usage="yes" |
| 323 | break |
| 324 | fi |
| 325 | android_root="$1" |
| 326 | run_args="${run_args} --android-root $1" |
| 327 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 328 | elif [ "x$1" = "x--update" ]; then |
| 329 | update_mode="yes" |
| 330 | shift |
| 331 | elif [ "x$1" = "x--help" ]; then |
| 332 | usage="yes" |
| 333 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 334 | elif [ "x$1" = "x--64" ]; then |
| 335 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 336 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 337 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 338 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 339 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 340 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 341 | elif [ "x$1" = "x--stream" ]; then |
| 342 | trace_stream="true" |
| 343 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 344 | elif [ "x$1" = "x--always-clean" ]; then |
| 345 | always_clean="yes" |
| 346 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 347 | elif [ "x$1" = "x--never-clean" ]; then |
| 348 | never_clean="yes" |
| 349 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 350 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 351 | run_args="${run_args} --dex2oat-swap" |
| 352 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 353 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 354 | shift |
| 355 | run_args="${run_args} --instruction-set-features $1" |
| 356 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 357 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 358 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 359 | usage="yes" |
| 360 | break |
| 361 | else |
| 362 | break |
| 363 | fi |
| 364 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 365 | |
| 366 | # tmp_dir may be relative, resolve. |
| 367 | # |
| 368 | # Cannot use realpath, as it does not exist on Mac. |
| 369 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 370 | # Cannot use readlink -m, as it does not exist on Mac. |
| 371 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 372 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 373 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 374 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 375 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 376 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 377 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 378 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 379 | fi |
| 380 | if [ "$gc_verify" = "true" ]; then |
| 381 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 382 | fi |
| 383 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 384 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 385 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 386 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 387 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 388 | if [ "$trace_stream" = "true" ]; then |
| 389 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 390 | # the ability to analyze the file and just write to /dev/null. |
| 391 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 392 | # Enable streaming mode. |
| 393 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 394 | else |
| 395 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 396 | fi |
| 397 | elif [ "$trace_stream" = "true" ]; then |
| 398 | echo "Cannot use --stream without --trace." |
| 399 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 400 | fi |
| 401 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 402 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 403 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 404 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 405 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 406 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 407 | if [ "x${suffix64}" = "x64" ]; then |
| 408 | target_arch_name=${grep64bit} |
| 409 | else |
| 410 | target_arch_name=${grep32bit} |
| 411 | fi |
| 412 | } |
| 413 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 414 | function guess_host_arch_name() { |
| 415 | if [ "x${suffix64}" = "x64" ]; then |
| 416 | host_arch_name="x86_64" |
| 417 | else |
| 418 | host_arch_name="x86" |
| 419 | fi |
| 420 | } |
| 421 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 422 | if [ "$target_mode" = "no" ]; then |
| 423 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 424 | if [ "$prebuild_mode" = "yes" ]; then |
| 425 | echo "--prebuild with --jvm is unsupported"; |
| 426 | exit 1; |
| 427 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 428 | fi |
| 429 | fi |
| 430 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 431 | if [ "$have_patchoat" = "no" ]; then |
| 432 | run_args="${run_args} --no-patchoat" |
| 433 | fi |
| 434 | |
| 435 | if [ "$have_dex2oat" = "no" ]; then |
| 436 | run_args="${run_args} --no-dex2oat" |
| 437 | fi |
| 438 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 439 | if [ ! "$runtime" = "jvm" ]; then |
| 440 | run_args="${run_args} --lib $lib" |
| 441 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 442 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 443 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 444 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 445 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 446 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 447 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 448 | else |
| 449 | true # defaults to using target BOOTCLASSPATH |
| 450 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 451 | elif [ "$runtime" = "art" ]; then |
| 452 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 453 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 454 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 455 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 456 | fi |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 457 | guess_host_arch_name |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 458 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 459 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 460 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 461 | guess_target_arch_name |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 462 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 463 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 464 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 465 | if [ "$relocate" = "yes" ]; then |
| 466 | run_args="${run_args} --relocate" |
| 467 | else |
| 468 | run_args="${run_args} --no-relocate" |
| 469 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 470 | elif [ "$runtime" = "jvm" ]; then |
| 471 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 472 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 473 | fi |
| 474 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 475 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 476 | if [ "$runtime" != "art" ]; then |
| 477 | echo "--no-image is only supported on the art runtime" |
| 478 | exit 1 |
| 479 | fi |
| 480 | if [ "$target_mode" = "no" ]; then |
| 481 | framework="${ANDROID_HOST_OUT}/framework" |
| 482 | bpath_suffix="-hostdex" |
| 483 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 484 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 485 | bpath_suffix="" |
| 486 | fi |
| 487 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 488 | # fail since these jar files will be stripped. |
| 489 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 490 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 491 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 492 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 493 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 494 | # Pass down the bootclasspath |
| 495 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 496 | run_args="${run_args} --no-image" |
| 497 | fi |
| 498 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 499 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 500 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 501 | usage="yes" |
| 502 | fi |
| 503 | |
| 504 | if [ "$usage" = "no" ]; then |
| 505 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 506 | test_dir=`basename "$oldwd"` |
| 507 | else |
| 508 | test_dir="$1" |
| 509 | fi |
| 510 | |
| 511 | if [ '!' -d "$test_dir" ]; then |
| 512 | td2=`echo ${test_dir}-*` |
| 513 | if [ '!' -d "$td2" ]; then |
| 514 | echo "${test_dir}: no such test directory" 1>&2 |
| 515 | usage="yes" |
| 516 | fi |
| 517 | test_dir="$td2" |
| 518 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 519 | # Shift to get rid of the test name argument. The rest of the arguments |
| 520 | # will get passed to the test run. |
| 521 | shift |
| 522 | fi |
| 523 | |
| 524 | if [ "$usage" = "yes" ]; then |
| 525 | prog=`basename $prog` |
| 526 | ( |
| 527 | echo "usage:" |
| 528 | echo " $prog --help Print this message." |
| 529 | echo " $prog [options] [test-name] Run test normally." |
| 530 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 531 | "(dumps to stdout)." |
| 532 | echo " $prog --update [options] [test-name] Update mode" \ |
| 533 | "(replaces expected.txt)." |
| 534 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 535 | "current directory." |
| 536 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 537 | echo " -O Run non-debug rather than debug build (off by default)." |
| 538 | echo " -Xcompiler-option Pass an option to the compiler." |
| 539 | echo " --runtime-option Pass an option to the runtime." |
| 540 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 541 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 542 | echo " --gdb Run under gdb; incompatible with some tests." |
| 543 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 544 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 545 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 546 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 547 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 548 | echo " --optimizing Enable optimizing compiler (default)." |
| 549 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 550 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 551 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 552 | echo " Verification is enabled if neither --no-verify" |
| 553 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 554 | echo " --no-optimize Turn off optimization (on by default)." |
| 555 | echo " --no-precise Turn off precise GC (on by default)." |
| 556 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 557 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 558 | echo " other runtime options are ignored." |
| 559 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 560 | echo " --no-patchoat Run as though patchoat was failing." |
| 561 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 562 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 563 | echo " the test." |
| 564 | echo " --relocate Force the use of relocating in the test, making" |
| 565 | echo " the image and oat files be relocated to a random" |
| 566 | echo " address before running. (default)" |
| 567 | echo " --no-relocate Force the use of no relocating in the test" |
| 568 | echo " --host Use the host-mode virtual machine." |
| 569 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 570 | echo " --dalvik Use Dalvik (off by default)." |
| 571 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame^] | 572 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 573 | echo " to find the java compiler and runtime" |
| 574 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 575 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 576 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 577 | echo " --64 Run the test in 64-bit mode" |
| 578 | echo " --trace Run with method tracing" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 579 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 580 | echo " --gcstress Run with gc stress testing" |
| 581 | echo " --gcverify Run with gc verification" |
| 582 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 583 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 584 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 585 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 586 | echo " --instruction-set-features [string]" |
| 587 | echo " Set instruction-set-features for compilation." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 588 | ) 1>&2 |
| 589 | exit 1 |
| 590 | fi |
| 591 | |
| 592 | cd "$test_dir" |
| 593 | test_dir=`pwd` |
| 594 | |
| 595 | td_info="${test_dir}/${info}" |
| 596 | td_expected="${test_dir}/${expected}" |
| 597 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 598 | if [ ! -r $td_info ]; then |
| 599 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 600 | exit 1 |
| 601 | fi |
| 602 | |
| 603 | if [ ! -r $td_expected ]; then |
| 604 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 605 | exit 1 |
| 606 | fi |
| 607 | |
| 608 | # copy the test to a temp dir and run it |
| 609 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 610 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 611 | |
| 612 | rm -rf "$tmp_dir" |
| 613 | cp -Rp "$test_dir" "$tmp_dir" |
| 614 | cd "$tmp_dir" |
| 615 | |
| 616 | if [ '!' -r "$build" ]; then |
| 617 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 618 | else |
| 619 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 620 | fi |
| 621 | |
| 622 | if [ '!' -r "$run" ]; then |
| 623 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 624 | else |
| 625 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 626 | fi |
| 627 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 628 | if [ '!' -r "$check_cmd" ]; then |
| 629 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 630 | else |
| 631 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 632 | fi |
| 633 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 634 | chmod 755 "$build" |
| 635 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 636 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 637 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 638 | export TEST_NAME=`basename ${test_dir}` |
| 639 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 640 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 641 | # Checker when compiled with Optimizing on host. |
| 642 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 643 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 644 | # better resembles the Java source. We always build the DEX the same way, even |
| 645 | # if Checker is not invoked and the test only runs the program. |
| 646 | build_args="${build_args} --dx-option --no-optimize" |
| 647 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 648 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 649 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 650 | USE_JACK="false" |
| 651 | |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 652 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 653 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 654 | # patchoat are available. Disable Checker otherwise (b/22552692). |
| 655 | if [ "$prebuild_mode" = "yes" ] || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
| 656 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 657 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 658 | if [ "$target_mode" = "no" ]; then |
| 659 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 660 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 661 | else |
| 662 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 663 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 664 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 665 | |
| 666 | if [ "$debuggable" = "yes" ]; then |
| 667 | checker_args="$checker_args --debuggable" |
| 668 | fi |
| 669 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 670 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 671 | -Xcompiler-option -j1" |
| 672 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 673 | fi |
| 674 | fi |
| 675 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 676 | if [ "$runtime" != "jvm" ]; then |
| 677 | run_args="${run_args} --testlib ${testlib}" |
| 678 | fi |
| 679 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 680 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 681 | build_file_size_limit=2048 |
| 682 | run_file_size_limit=2048 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 683 | if echo "$test_dir" | grep 089; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 684 | build_file_size_limit=5120 |
| 685 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 686 | elif echo "$test_dir" | grep 083; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 687 | build_file_size_limit=5120 |
| 688 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 689 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 690 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 691 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 692 | # run checker on it. This file can be big. |
| 693 | build_file_size_limit=16384 |
| 694 | run_file_size_limit=16384 |
| 695 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 696 | if [ ${USE_JACK} = "false" ]; then |
| 697 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 698 | if ! ulimit -S "$build_file_size_limit"; then |
| 699 | echo "ulimit file size setting failed" |
| 700 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 701 | fi |
| 702 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 703 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 704 | good_build="yes" |
| 705 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 706 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 707 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 708 | build_exit="$?" |
| 709 | echo "build exit status: $build_exit" 1>&2 |
| 710 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 711 | if ! ulimit -S "$run_file_size_limit"; then |
| 712 | echo "ulimit file size setting failed" |
| 713 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 714 | echo "${test_dir}: running..." 1>&2 |
| 715 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 716 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 717 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 718 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 719 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 720 | if [ "$target_mode" = "yes" ]; then |
| 721 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 722 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 723 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 724 | checker_exit="$?" |
| 725 | if [ "$checker_exit" = "0" ]; then |
| 726 | good="yes" |
| 727 | fi |
| 728 | echo "checker exit status: $checker_exit" 1>&2 |
| 729 | else |
| 730 | good="yes" |
| 731 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 732 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 733 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 734 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 735 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 736 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 737 | build_exit="$?" |
| 738 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 739 | if ! ulimit -S "$run_file_size_limit"; then |
| 740 | echo "ulimit file size setting failed" |
| 741 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 742 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 743 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 744 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 745 | if [ "$target_mode" = "yes" ]; then |
| 746 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 747 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 748 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 749 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 750 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 751 | good="yes" |
| 752 | else |
| 753 | cat "$build_output" 1>&2 |
| 754 | echo "build exit status: $build_exit" 1>&2 |
| 755 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 756 | elif [ "$build_only" = "yes" ]; then |
| 757 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 758 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 759 | build_exit="$?" |
| 760 | if [ "$build_exit" '!=' '0' ]; then |
| 761 | cp "$build_output" "$output" |
| 762 | echo "build exit status: $build_exit" >>"$output" |
| 763 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 764 | if [ "$?" '!=' "0" ]; then |
| 765 | good="no" |
| 766 | echo "BUILD FAILED For ${TEST_NAME}" |
| 767 | fi |
| 768 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 769 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 770 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 771 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 772 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 773 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 774 | build_exit="$?" |
| 775 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 776 | if ! ulimit -S "$run_file_size_limit"; then |
| 777 | echo "ulimit file size setting failed" |
| 778 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 779 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 780 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 781 | run_exit="$?" |
| 782 | if [ "$run_exit" != "0" ]; then |
| 783 | echo "run exit status: $run_exit" 1>&2 |
| 784 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 785 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 786 | if [ "$target_mode" = "yes" ]; then |
| 787 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 788 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 789 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 790 | checker_exit="$?" |
| 791 | if [ "$checker_exit" != "0" ]; then |
| 792 | echo "checker exit status: $checker_exit" 1>&2 |
| 793 | good_run="no" |
| 794 | else |
| 795 | good_run="yes" |
| 796 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 797 | else |
| 798 | good_run="yes" |
| 799 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 800 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 801 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 802 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 803 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 804 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 805 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 806 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 807 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 808 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 809 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 810 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 811 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 812 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 813 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 814 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 815 | # output == expected |
| 816 | good="yes" |
| 817 | echo "${test_dir}: succeeded!" 1>&2 |
| 818 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 819 | fi |
| 820 | fi |
| 821 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 822 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 823 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 824 | echo "${test_dir}: FAILED!" |
| 825 | echo ' ' |
| 826 | echo '#################### info' |
| 827 | cat "${td_info}" | sed 's/^/# /g' |
| 828 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 829 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 830 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 831 | if [ "$strace" = "yes" ]; then |
| 832 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 833 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 834 | echo '####################' |
| 835 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 836 | echo ' ' |
| 837 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 838 | |
| 839 | ) 1>&2 |
| 840 | |
| 841 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 842 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 843 | cd "$oldwd" |
| 844 | rm -rf "$tmp_dir" |
| 845 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 846 | adb shell rm -rf $DEX_LOCATION |
| 847 | fi |
| 848 | if [ "$good" = "yes" ]; then |
| 849 | exit 0 |
| 850 | fi |
| 851 | fi |
| 852 | |
| 853 | |
| 854 | ( |
| 855 | if [ "$always_clean" = "yes" ]; then |
| 856 | echo "${TEST_NAME} files deleted from host " |
| 857 | if [ "$target_mode" == "yes" ]; then |
| 858 | echo "and from target" |
| 859 | fi |
| 860 | else |
| 861 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 862 | if [ "$target_mode" == "yes" ]; then |
| 863 | echo "and in ${DEX_LOCATION} on target" |
| 864 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 865 | fi |
| 866 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 867 | ) 1>&2 |
| 868 | |
| 869 | exit 1 |